﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;

namespace ValueListSample1
{
    public partial class Form1 : Form
    {


        public List<DataItem> DataItems
        {
            get
            {
                List<DataItem> lst = new List<DataItem>();

                lst.Add(new DataItem() { Name = "Name1", SomeValue = (int)SampleEnum.Value1 });
                lst.Add(new DataItem() { Name = "Name2", SomeValue = (int)SampleEnum.Value2 });
                lst.Add(new DataItem() { Name = "Name3", SomeValue = (int)SampleEnum.Value3 });

                return lst;
            }
        }

        private static ValueList _sampleValueList1;
        public ValueList SampleValueList1
        {
            get
            {
                if (_sampleValueList1 == null)
                {
                    _sampleValueList1 = new ValueList();

                    foreach (string name in Enum.GetNames(typeof(SampleEnum)))
                    {
                        ValueListItem itm = new ValueListItem((int)Enum.Parse(typeof(SampleEnum), name), name);
                        _sampleValueList1.ValueListItems.Add(itm);
                    }
                }

                return _sampleValueList1;
            }
        }

        class app : IValueAppearance
        {
            public event EventHandler PropertyChanged;

            public void ResolveAppearance(ref AppearanceData appData, ref AppearancePropFlags flags, object dataValue, IConditionContextProvider context)
            {
                switch (_sampleValueList1.ValueListItems[_sampleValueList1.FindStringExact(dataValue.ToString())].DataValue.ToString())
                {
                    case "10": appData.BackColor = Color.Red;
                        break;
                    case "20": appData.BackColor = Color.Gray;
                        break;
                    case "30": appData.BackColor = Color.Blue;
                        break;
                }
            }

            public object Clone()
            {
                throw new NotImplementedException();
            }
        }

        protected void LoadData()
        {
            grdSample1.DataSource = DataItems;
            grdSample1.DisplayLayout.Bands[0].Columns["SomeValue"].ValueList = SampleValueList1;
            grdSample1.DisplayLayout.Bands[0].Columns["SomeValue"].ValueBasedAppearance = new app();
        }


        public Form1()
        {
            InitializeComponent();
        }

        private void btnLoadData_Click(object sender, EventArgs e)
        {
            LoadData();
        }
    }


    public class DataItem
    {
        public string Name { get; set;}
        public int SomeValue { get; set; }
    }

    public enum SampleEnum
    {
        Value1 = 10,
        Value2 = 20,
        Value3 = 30
    }
}
